wxWidgets: wxLongLong Class Reference

| Version: 3.0.4

Public Member Functions | List of all members
wxLongLong Class Reference
Class List by Category » Data Structures

`#include </usr/src/ports/wxWidgets3.0/wxWidgets3.0-3.0.4-1.i686/src/wxWidgets-3.0.4/interface/wx/longlong.h>`

## Detailed Description

This class represents a signed 64 bit long number.

It is implemented using the native 64 bit type where available (machines with 64 bit longs or compilers which have (an analog of) long long type) and uses the emulation code in the other cases which ensures that it is the most efficient solution for working with 64 bit integers independently of the architecture.

wxLongLong defines all usual arithmetic operations such as addition, subtraction, bitwise shifts and logical operations as well as multiplication and division (not yet for the machines without native long long). It also has operators for implicit construction from and conversion to the native long long type if it exists and long.

You would usually use this type in exactly the same manner as any other (built-in) arithmetic type. Note that wxLongLong is a signed type, if you want unsigned values use wxULongLong which has exactly the same API as wxLongLong except when explicitly mentioned otherwise.

If a native (i.e. supported directly by the compiler) 64 bit integer type was found to exist, wxLongLong_t macro will be defined to correspond to it. Also, in this case only, two additional macros will be defined:

- wxLongLongFmtSpec() for printing 64 bit integers using the standard `printf()` function (but see also wxLongLong::ToString for a more portable solution);
- wxLL() for defining 64 bit integer compile-time constants.

##

Library: wxBase

<>< =''>:</>&;&;< =''>\ </></>

## Public Member Functions
| wxLongLong ()
| Default constructor initializes the object to 0. More...
| wxLongLong (wxLongLong_t ll)
| Constructor from native long long (only for compilers supporting it). More...
| wxLongLong (long hi, unsigned long lo)
| Constructor from 2 longs: the high and low part are combined into one wxLongLong. More...
wxLongLong | Assign (double d)
| This allows to convert a double value to wxLongLong type. More...
long | GetHi () const
| Returns the high 32 bits of 64 bit integer. More...
unsigned long | GetLo () const
| Returns the low 32 bits of 64 bit integer. More...
wxLongLong_t | GetValue () const
| Convert to native long long (only for compilers supporting it). More...
double | ToDouble () const
| Returns the value as `double`. More...
long | ToLong () const
| Truncate wxLongLong to long. More...
wxString | ToString () const
| Returns the string representation of a wxLongLong. More...
wxLongLong | operator+ (const wxLongLong &ll) const
| Adds 2 wxLongLongs together and returns the result. More...
wxLongLong & | operator+ (const wxLongLong &ll)
| Add another wxLongLong to this one. More...
wxLongLong | operator- (const wxLongLong &ll) const
| Subtracts 2 wxLongLongs and returns the result. More...
wxLongLong & | operator- (const wxLongLong &ll)
| Subtracts another wxLongLong from this one. More...
wxLongLong | operator- () const
| Returns the value of this wxLongLong with opposite sign. More...
wxLongLong & | operator= (const wxULongLong &ll)
| Assignment operator from unsigned long long. More...
wxLongLong & | operator= (wxLongLong_t ll)
| Assignment operator from native long long (only for compilers supporting it). More...
wxLongLong & | operator= (wxULongLong_t ll)
| Assignment operator from native unsigned long long (only for compilers supporting it). More...
wxLongLong & | operator= (long l)
| Assignment operator from long. More...
wxLongLong & | operator= (unsigned long l)
| Assignment operator from unsigned long. More...
wxLongLong | Abs () const
| Returns an absolute value of wxLongLong - either making a copy (const version) or modifying it in place (the second one). More...
wxLongLong & | Abs ()
| Returns an absolute value of wxLongLong - either making a copy (const version) or modifying it in place (the second one). More...
wxLongLong | operator++ ()
| Pre/post increment operator. More...
wxLongLong | operator++ (int)
| Pre/post increment operator. More...
wxLongLong | operator-- ()
| Pre/post decrement operator. More...
wxLongLong | operator-- (int)
| Pre/post decrement operator. More...

## Constructor & Destructor Documentation

## ◆ wxLongLong() [1/3]

wxLongLong::wxLongLong | ( |  | ) |

Default constructor initializes the object to 0.

## ◆ wxLongLong() [2/3]

wxLongLong::wxLongLong | ( | wxLongLong_t | ll | ) |

Constructor from native long long (only for compilers supporting it).

## ◆ wxLongLong() [3/3]

wxLongLong::wxLongLong | ( | long | hi,
|  | unsigned long | lo
| ) |  |

Constructor from 2 longs: the high and low part are combined into one wxLongLong.

## Member Function Documentation

## ◆ Abs() [1/2]

wxLongLong wxLongLong::Abs | ( |  | ) | const

Returns an absolute value of wxLongLong - either making a copy (const version) or modifying it in place (the second one).

Not in wxULongLong.

## ◆ Abs() [2/2]

wxLongLong& wxLongLong::Abs | ( |  | ) |

Returns an absolute value of wxLongLong - either making a copy (const version) or modifying it in place (the second one).

Not in wxULongLong.

## ◆ Assign()

wxLongLong wxLongLong::Assign | ( | double | d | ) |

This allows to convert a double value to wxLongLong type.

Such conversion is not always possible in which case the result will be silently truncated in a platform-dependent way. Not in wxULongLong.

## ◆ GetHi()

long wxLongLong::GetHi | ( |  | ) | const

Returns the high 32 bits of 64 bit integer.

## ◆ GetLo()

unsigned long wxLongLong::GetLo | ( |  | ) | const

Returns the low 32 bits of 64 bit integer.

## ◆ GetValue()

wxLongLong_t wxLongLong::GetValue | ( |  | ) | const

Convert to native long long (only for compilers supporting it).

## ◆ operator+() [1/2]

wxLongLong wxLongLong::operator+ | ( | const wxLongLong & | ll | ) | const

Adds 2 wxLongLongs together and returns the result.

## ◆ operator+() [2/2]

wxLongLong& wxLongLong::operator+ | ( | const wxLongLong & | ll | ) |

Add another wxLongLong to this one.

## ◆ operator++() [1/2]

wxLongLong wxLongLong::operator++ | ( |  | ) |

Pre/post increment operator.

## ◆ operator++() [2/2]

wxLongLong wxLongLong::operator++ | ( | int |  | ) |

Pre/post increment operator.

## ◆ operator-() [1/3]

wxLongLong wxLongLong::operator- | ( | const wxLongLong & | ll | ) | const

Subtracts 2 wxLongLongs and returns the result.

## ◆ operator-() [2/3]

wxLongLong& wxLongLong::operator- | ( | const wxLongLong & | ll | ) |

Subtracts another wxLongLong from this one.

## ◆ operator-() [3/3]

wxLongLong wxLongLong::operator- | ( |  | ) | const

Returns the value of this wxLongLong with opposite sign.

Not in wxULongLong.

## ◆ operator--() [1/2]

wxLongLong wxLongLong::operator-- | ( |  | ) |

Pre/post decrement operator.

## ◆ operator--() [2/2]

wxLongLong wxLongLong::operator-- | ( | int |  | ) |

Pre/post decrement operator.

## ◆ operator=() [1/5]

wxLongLong& wxLongLong::operator= | ( | const wxULongLong & | ll | ) |

Assignment operator from unsigned long long.

The sign bit will be copied too.

Since
  2.7.0

## ◆ operator=() [2/5]

wxLongLong& wxLongLong::operator= | ( | wxLongLong_t | ll | ) |

Assignment operator from native long long (only for compilers supporting it).

## ◆ operator=() [3/5]

wxLongLong& wxLongLong::operator= | ( | wxULongLong_t | ll | ) |

Assignment operator from native unsigned long long (only for compilers supporting it).

Since
  2.7.0

## ◆ operator=() [4/5]

wxLongLong& wxLongLong::operator= | ( | long | l | ) |

Assignment operator from long.

Since
  2.7.0

## ◆ operator=() [5/5]

wxLongLong& wxLongLong::operator= | ( | unsigned long | l | ) |

Assignment operator from unsigned long.

Since
  2.7.0

## ◆ ToDouble()

double wxLongLong::ToDouble | ( |  | ) | const

Returns the value as `double`.

## ◆ ToLong()

long wxLongLong::ToLong | ( |  | ) | const

Truncate wxLongLong to long.

If the conversion loses data (i.e. the wxLongLong value is outside the range of built-in long type), an assert will be triggered in debug mode.

## ◆ ToString()

wxString wxLongLong::ToString | ( |  | ) | const

Returns the string representation of a wxLongLong.